<script setup lang="ts">
    import { graphql } from "./../../gql/index";
    import { computed } from "vue";
    import useNavigationStore from "./../../stores/navigation";
    import { useQuery, useMutation } from "@vue/apollo-composable";
    import { EventtypeEnum } from "../../gql/graphql";

    const navigationStore = useNavigationStore();

    // current events
    const participantQueryVariables = computed(() => {
        return {
            id: navigationStore.participantId,
        };
    });
    const participantEventsQuery = graphql(`
        query ParticipantEventsQuery($id: Uuid = "00000000-0000-0000-0000-000000000000") {
            participant(id: $id) {
                id
                extensions {
                    id
                    event {
                        id
                    }
                }
            }
        }
    `);
    const { result: resultParticipantEvents } = useQuery(participantEventsQuery, participantQueryVariables, {
        fetchPolicy: "cache-and-network",
    });
    const currentEventIds = computed(() => {
        let extensions = resultParticipantEvents.value?.participant!.extensions! ?? [];
        let res = [] as string[];

        extensions.forEach((extension) => {
            res.push(extension.event?.id);
        });

        return res;
    });

    // all events
    const eventsQuery = graphql(`
        query EventNamesAndIds {
            allEvents {
                id
                name
                year
                startDate
                type
            }
        }
    `);
    const { result: eventsResult } = useQuery(eventsQuery, null, {
        fetchPolicy: "cache-and-network",
    });
    const events = computed(() => {
        let res = eventsResult.value?.allEvents! ?? [];

        let filtered = res.filter((event) => {
            // participants cannot go to the PreparationWeekend (in the gui. They could be added over graphql)
            return event.type != EventtypeEnum.PreparationWeekend && !currentEventIds.value.includes(event.id);
        });

        // more recent events are more to the top
        filtered.sort((a, b) => {
            return b.startDate.localeCompare(a.startDate);
        });

        return filtered;
    });

    // mutation
    const addingMutation = graphql(`
        mutation AddEventToParticipantMutation(
            $eventId: Uuid = "00000000-0000-0000-0000-000000000000"
            $participantId: Uuid = "00000000-0000-0000-0000-000000000000"
        ) {
            createParticipantExtension(values: { participantId: $participantId, eventId: $eventId }) {
                id
                # Below stuff needs to be queried, so that the cache is updated!
                participant {
                    id
                    extensions {
                        id
                    }
                }
            }
        }
    `);
    const { mutate: addToEvent } = useMutation(addingMutation, () => ({
        fetchPolicy: "network-only",
    }));

    async function addParticipantToEvent(id: string) {
        addToEvent({
            participantId: navigationStore.participantId,
            eventId: id,
        });

        navigationStore.participantViewTab = id;
        // this navigates, because the $subscribe somewhere
    }
</script>

<template>
    <template v-for="event in events" :key="event.id">
        <p class="py-2">
            <b>{{ event.name }} ({{ event.year }})</b>:
            <v-btn @click="addParticipantToEvent(event.id)" class="ml-5">
                <template v-slot:prepend> <span class="material-symbols-outlined"> add </span></template>
                Hinzufügen
            </v-btn>
        </p>
    </template>
    <p v-if="events.length == 0">Der Teilnehmer ist bereits in allen verfügbaren Veranstaltungen eingetragen</p>
</template>
